/* nuke.c */
/* nukes cracker's jobs. Improvements welcome... I want those sessions
 * nuked to reduce their connect time. */

#include "config.h"
#include <stdio.h>
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif /* HAVE_STDLIB_H */
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */
#ifdef HAVE_SIGNAL_H
#include <signal.h>
#endif /* HAVE_SIGNAL_H */
#ifdef HAVE_UNISTD_H 
#include <unistd.h>
#endif /* HAVE_UNISTD_H */
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif /* HAVE_ERRNO_H */
#include "prog.h"


#ifdef CPS_OS_RD_STAT
static int send_sig(int pid, int sig)
{
    int res;
    
    if (pid==1 || pid==getpid())
    {
	do_log("Not nuking pid %d", pid);
	return 1;
    }
#ifdef DEBUG
    do_log("Nuke pid %d", pid);
#else
    res=kill(pid, sig);
#endif
    if (res!=0)
    {
	switch(errno)
	{
	case ESRCH:
	    return 1;
	    
	case EPERM:
	    do_log("Lacked permsission to kill pid %d", pid);
	    return 1;
	    
	case EINVAL:
	    do_log("Signal %d invalid (pid %d)", sig, pid);
	    break;
	    
	default:
	    do_log("Unexpected error number %d (pid %d)", errno, pid);
	    break;
	}
	return 1;
    }
    return 1;
}
#endif /* CPS_OS_RD_STAT */

int nuke_proc(int pid)
{
    int res;
#ifdef CPS_OS_RD_STAT
    int i;
    int *pids;
#endif /* CPS_OS_RD_STAT */

    if (zap_mode==0)
    {
#ifdef CPS_OS_RD_STAT
	pids=os_read_stat(pid);	/* Log the intreseting information */
#endif /* CPS_OS_RD_STAT */
	free(pids);
	return 1;		/* No signal mode  */
    }

#ifdef DEBUG
    do_log("Stop pid %d, zap mode %d", pid, zap_mode);
    res=0;
#else
    res=kill(pid, SIGSTOP);
#endif
    if (res!=0)
    {
	switch(errno)
	{
	case ESRCH:
	   return 0;

	case EPERM:
	   do_log("Lacked permsission to kill pid %d", pid);
	   return 1;

	case EINVAL:
	   do_log("Signal %d invalid (pid %d)", SIGSTOP, pid);
	   return 1;

	default:
	   do_log("Unexpected error number %d (pid %d)", errno, pid);
	   return 1;
	}
    }
    /* If we get here then we sent a signal, the task existis and we
       have permission. It is time to get though on the process and
       log information. */
#ifdef CPS_OS_RD_STAT
    pids=os_read_stat(pid);	/* Log the intreseting information */
    if (pids!=NULL)
    {
#ifdef HAVE_NICE
	nice(-10);		/* Ensure high scheduling priority */
#endif /* HAVE_NICE */
	/* Stop the processes keeping track of each other */
	for (i=0; i<3; i++)
	{
	    send_sig(pids[i], SIGSTOP);
	}
	send_sig(pid, SIGSTOP);
	if (zap_mode==1)
	{
	    nice(10);		/* Back to normal */
	    return;		/* Halt mode */
	}

	/* nuke the processes */
	for (i=0; i<3; i++)
	{
	    send_sig(pids[i], SIGKILL);
	}
	send_sig(pid, SIGKILL);
#ifdef HAVE_NICE
	nice(10);		/* Back to normal. */
#endif /* HAVE_NICE */
	free(pids);
	return 1;
    }
#endif /* CPS_OS_RD_STAT */
#ifdef DEBUG
    do_log("%s pid %d", (zap_mode==1) ? "halt" : "kill", pid);
#else
    res=kill(pid, (zap_mode==1) ? SIGSTOP : SIGKILL);	/* Nuke "hidden" pid */
#endif
    return 1;
}
