/* $Id: prog.h,v 1.5 2000/10/10 22:10:43 dps Exp $ */
/* Symbols passed between source files */

#ifndef __CHECK_PS_PROG_H___
#define __CHECK_PS_PROG_H___ 1

#include <stdio.h>
#include <stddef.h>
#include "config.h"
#include "numbuf.h"
#ifndef NULL
#define NULL (void *) 0
#endif

typedef enum { __LOG_SYSLOG, __LOG_FILE,
	       __LOG_EMAIL } logtype;		      /* Log mode */

#ifdef CPS_OS_RD_STAT
extern int *os_read_stat(int);			      /* OS specific /proc
						       * reading */
#endif /* CPS_OS_RD_STAT */

extern int nuke_proc(int);			      /* Nuke and log procs */
extern void do_log(const char *, ...);		      /* Logging. */
extern void log_start(void);			      /* Start recording */
extern void log_flush(void);			      /* Flush logs */
extern int smtp_send(const char *const *,
		     const char *);		      /* Sends email */
extern void email_test_host(void);		      /* SMTP relay=local? */
extern void ingore_signals(void);		      /* Ignore signals */
extern void demon_body(numbuf *(*pid_list)(void),
		       int (*current_proc)(int));     /* Demon mode code */
extern int one_shot(numbuf *(*pid_list)(void),	      /* One shot code */
		    int (*current_proc)(int));	      /* Demon mode code */

extern numbuf *pid_list(void);			      /* pid list code */
extern int current_process(int);		      /* current pid tester */
#ifdef HAVE_PKILL_CHECK
extern numbuf *pid_list_pkill(void);		      /* pid list code */
extern int current_process_pkill(int);		      /* current pid tester */
#endif
extern void enhanced_spoof_cleanup(const char *,      /* Removes program */
				   char **);	      /* used for spoofing */
extern FILE *pathsrch(const char *);		      /* $PATH relative 
						       * search for file */
extern int makedirs(int argc, char *argv[]);	      /* make directory
						       * and save options */
extern int copy_file(const char *, FILE *);	      /* File copy */
extern char **readargs(FILE *);			      /* Read saved args */
extern int count_vals(char **);			      /* Count values */

extern int zap_mode;				      /* Zap mode */
extern FILE *log_file;				      /* log file */
extern logtype log_mode;			      /* log mode */
extern int system_ok_msg;			      /* Unalarming normal messages */

/* time.c */
extern void fix_time(void);	/* Check check setup */
extern void check_time(int min, int max); /* Check clock */

#endif /*  __CHECK_PS_PROG_H___ */
